=== modified file 'Makefile.am'
--- Makefile.am	2010-02-12 01:44:42 +0000
+++ Makefile.am	2010-02-16 07:05:28 +0000
@@ -22,6 +22,7 @@
 noinst_HEADERS =
 nobase_nodist_include_HEADERS =
 nobase_dist_include_HEADERS =
+sbin_PROGRAMS =
 lib_LTLIBRARIES = 
 noinst_LTLIBRARIES =
 noinst_PROGRAMS =

=== modified file 'drizzled/data_home.h'
--- drizzled/data_home.h	2010-02-04 08:14:46 +0000
+++ drizzled/data_home.h	2010-02-16 07:05:28 +0000
@@ -20,12 +20,15 @@
 #ifndef DRIZZLED_DATA_HOME_H
 #define DRIZZLED_DATA_HOME_H
 
+/* @TODO: These don't need drizzle_ prefixes any longer */
 namespace drizzled
 {
 
 extern uint32_t drizzle_data_home_len;
-extern char *drizzle_data_home,
-             drizzle_real_data_home[], drizzle_unpacked_real_data_home[];
+extern char *drizzle_data_home;
+extern char drizzle_real_data_home[];
+extern char drizzle_unpacked_real_data_home[];
+extern char drizzle_data_home_buff[];
 
 } /* namespace drizzled */
 

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-02-13 23:50:31 +0000
+++ drizzled/drizzled.cc	2010-02-16 07:05:28 +0000
@@ -31,7 +31,6 @@
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/internal/my_bit.h"
 #include <drizzled/my_hash.h>
-#include <drizzled/stacktrace.h>
 #include <drizzled/error.h>
 #include <drizzled/errmsg_print.h>
 #include <drizzled/tztime.h>
@@ -51,6 +50,7 @@
 #include "drizzled/session_list.h"
 #include "drizzled/charset.h"
 #include "plugin/myisam/myisam.h"
+#include "drizzled/drizzled.h"
 
 #include <google/protobuf/stubs/common.h>
 
@@ -82,8 +82,6 @@
 #include <pwd.h>				// For getpwent
 #include <grp.h>
 
-#include <sys/resource.h>
-
 #ifdef HAVE_SELECT_H
 #  include <select.h>
 #endif
@@ -188,8 +186,8 @@
 /*
   Used with --help for detailed option
 */
-static bool opt_help= false;
-static bool opt_help_extended= false;
+bool opt_help= false;
+bool opt_help_extended= false;
 
 arg_cmp_func Arg_comparator::comparator_matrix[5][2] =
 {{&Arg_comparator::compare_string,     &Arg_comparator::compare_e_string},
@@ -200,12 +198,9 @@
 
 /* static variables */
 
-static bool volatile select_thread_in_use;
-static bool volatile ready_to_exit;
 static bool opt_debugging= 0;
 static uint32_t wake_thread;
-static uint32_t killed_threads;
-static char *drizzled_user, *drizzled_chroot;
+static char *drizzled_chroot;
 static char *language_ptr;
 static const char *default_character_set_name;
 static const char *character_set_filesystem_name;
@@ -216,6 +211,9 @@
 
 /* Global variables */
 
+bool volatile ready_to_exit;
+char *drizzled_user;
+bool volatile select_thread_in_use;
 bool volatile abort_loop;
 bool volatile shutdown_in_progress;
 uint32_t max_used_connections;
@@ -232,7 +230,7 @@
 
 char* opt_secure_file_priv= 0;
 
-static bool calling_initgroups= false; /**< Used in SIGSEGV handler. */
+bool calling_initgroups= false; /**< Used in SIGSEGV handler. */
 
 uint32_t drizzled_bind_timeout;
 std::bitset<12> test_flags;
@@ -344,7 +342,6 @@
 
 /* Static variables */
 
-static bool segfaulted;
 #ifdef HAVE_STACK_TRACE_ON_SEGV
 static bool opt_do_pstack;
 #endif /* HAVE_STACK_TRACE_ON_SEGV */
@@ -353,9 +350,7 @@
 static int defaults_argc;
 static char **defaults_argv;
 
-struct passwd *user_info;
-static pthread_t select_thread;
-static uint32_t thr_kill_signal;
+passwd *user_info;
 
 /**
   Number of currently active user connections. The variable is protected by
@@ -379,10 +374,8 @@
 static const char *get_relative_path(const char *path);
 static void fix_paths(string &progname);
 extern "C" pthread_handler_t handle_slave(void *arg);
-static void clean_up(bool print_message);
 
 static void usage(void);
-static void clean_up_mutexes(void);
 void close_connections(void);
  
 /****************************************************************************
@@ -467,20 +460,6 @@
   }
 }
 
-extern "C" void print_signal_warning(int sig);
-
-extern "C" void print_signal_warning(int sig)
-{
-  if (global_system_variables.log_warnings)
-    errmsg_printf(ERRMSG_LVL_WARN, _("Got signal %d from thread %"PRIu64),
-                  sig, global_thread_id);
-#ifndef HAVE_BSD_SIGNALS
-  my_sigset(sig,print_signal_warning);		/* int. thread system calls */
-#endif
-  if (sig == SIGALRM)
-    alarm(2);					/* reschedule alarm */
-}
-
 /**
   cleanup all memory and end program nicely.
 
@@ -517,7 +496,7 @@
 }
 
 
-static void clean_up(bool print_message)
+void clean_up(bool print_message)
 {
   if (cleanup_done++)
     return;
@@ -566,7 +545,7 @@
 } /* clean_up */
 
 
-static void clean_up_mutexes()
+void clean_up_mutexes()
 {
   (void) pthread_mutex_destroy(&LOCK_create_db);
   (void) pthread_mutex_destroy(&LOCK_open);
@@ -584,9 +563,9 @@
 
 /* Change to run as another user if started with --user */
 
-static struct passwd *check_user(const char *user)
+passwd *check_user(const char *user)
 {
-  struct passwd *tmp_user_info;
+  passwd *tmp_user_info;
   uid_t user_id= geteuid();
 
   // Don't bother if we aren't superuser
@@ -644,7 +623,7 @@
 
 }
 
-static void set_user(const char *user, struct passwd *user_info_arg)
+void set_user(const char *user, passwd *user_info_arg)
 {
   assert(user_info_arg != 0);
   /*
@@ -669,6 +648,7 @@
 }
 
 
+
 /** Change root user if started with @c --chroot . */
 static void set_root(const char *path)
 {
@@ -679,21 +659,6 @@
   }
 }
 
-extern "C" void end_thread_signal(int );
-
-/** Called when a thread is aborted. */
-extern "C" void end_thread_signal(int )
-{
-  Session *session=current_session;
-  if (session)
-  {
-    statistic_increment(killed_threads, &LOCK_status);
-    session->scheduler->killSessionNow(session);
-    DRIZZLE_CONNECTION_DONE(session->thread_id);
-  }
-  return;
-}
-
 
 /*
   Unlink session from global list of available connections and free session
@@ -741,148 +706,7 @@
 }
 #endif
 
-#if defined(BACKTRACE_DEMANGLE)
-#include <cxxabi.h>
-extern "C" char *my_demangle(const char *mangled_name, int *status)
-{
-  return abi::__cxa_demangle(mangled_name, NULL, NULL, status);
-}
-#endif
-
-extern "C" void handle_segfault(int sig);
-
-extern "C" void handle_segfault(int sig)
-{
-  time_t curr_time;
-  struct tm tm;
-
-  /*
-    Strictly speaking, one needs a mutex here
-    but since we have got SIGSEGV already, things are a mess
-    so not having the mutex is not as bad as possibly using a buggy
-    mutex - so we keep things simple
-  */
-  if (segfaulted)
-  {
-    fprintf(stderr, _("Fatal signal %d while backtracing\n"), sig);
-    exit(1);
-  }
-
-  segfaulted = 1;
-
-  curr_time= time(NULL);
-  if(curr_time == (time_t)-1)
-  {
-    fprintf(stderr, "Fetal: time() call failed\n");
-    exit(1);
-  }
-
-  localtime_r(&curr_time, &tm);
-  
-  fprintf(stderr,"%02d%02d%02d %2d:%02d:%02d - drizzled got signal %d;\n"
-          "This could be because you hit a bug. It is also possible that "
-          "this binary\n or one of the libraries it was linked against is "
-          "corrupt, improperly built,\n or misconfigured. This error can "
-          "also be caused by malfunctioning hardware.\n",
-          tm.tm_year % 100, tm.tm_mon+1, tm.tm_mday,
-          tm.tm_hour, tm.tm_min, tm.tm_sec,
-          sig);
-  fprintf(stderr, _("We will try our best to scrape up some info that "
-                    "will hopefully help diagnose\n"
-                    "the problem, but since we have already crashed, "
-                    "something is definitely wrong\nand this may fail.\n\n"));
-  fprintf(stderr, "key_buffer_size=%u\n",
-          (uint32_t) dflt_key_cache->key_cache_mem_size);
-  fprintf(stderr, "read_buffer_size=%ld\n", (long) global_system_variables.read_buff_size);
-  fprintf(stderr, "max_used_connections=%u\n", max_used_connections);
-  fprintf(stderr, "connection_count=%u\n", uint32_t(connection_count));
-  fprintf(stderr, _("It is possible that drizzled could use up to \n"
-                    "key_buffer_size + (read_buffer_size + "
-                    "sort_buffer_size)*thread_count\n"
-                    "bytes of memory\n"
-                    "Hope that's ok; if not, decrease some variables in the "
-                    "equation.\n\n"));
-
-#ifdef HAVE_STACKTRACE
-  Session *session= current_session;
-
-  if (! (test_flags.test(TEST_NO_STACKTRACE)))
-  {
-    fprintf(stderr,"session: 0x%lx\n",(long) session);
-    fprintf(stderr,_("Attempting backtrace. You can use the following "
-                     "information to find out\n"
-                     "where drizzled died. If you see no messages after this, "
-                     "something went\n"
-                     "terribly wrong...\n"));
-    print_stacktrace(session ? (unsigned char*) session->thread_stack : (unsigned char*) 0,
-                     my_thread_stack_size);
-  }
-  if (session)
-  {
-    const char *kreason= "UNKNOWN";
-    switch (session->killed) {
-    case Session::NOT_KILLED:
-      kreason= "NOT_KILLED";
-      break;
-    case Session::KILL_BAD_DATA:
-      kreason= "KILL_BAD_DATA";
-      break;
-    case Session::KILL_CONNECTION:
-      kreason= "KILL_CONNECTION";
-      break;
-    case Session::KILL_QUERY:
-      kreason= "KILL_QUERY";
-      break;
-    case Session::KILLED_NO_VALUE:
-      kreason= "KILLED_NO_VALUE";
-      break;
-    }
-    fprintf(stderr, _("Trying to get some variables.\n"
-                      "Some pointers may be invalid and cause the "
-                      "dump to abort...\n"));
-    safe_print_str("session->query", session->query, 1024);
-    fprintf(stderr, "session->thread_id=%"PRIu32"\n", (uint32_t) session->thread_id);
-    fprintf(stderr, "session->killed=%s\n", kreason);
-  }
-  fflush(stderr);
-#endif /* HAVE_STACKTRACE */
-
-  if (calling_initgroups)
-    fprintf(stderr, _("\nThis crash occurred while the server was calling "
-                      "initgroups(). This is\n"
-                      "often due to the use of a drizzled that is statically "
-                      "linked against glibc\n"
-                      "and configured to use LDAP in /etc/nsswitch.conf. "
-                      "You will need to either\n"
-                      "upgrade to a version of glibc that does not have this "
-                      "problem (2.3.4 or\n"
-                      "later when used with nscd), disable LDAP in your "
-                      "nsswitch.conf, or use a\n"
-                      "drizzled that is not statically linked.\n"));
-
-  if (internal::thd_lib_detected == THD_LIB_LT && !getenv("LD_ASSUME_KERNEL"))
-    fprintf(stderr,
-            _("\nYou are running a statically-linked LinuxThreads binary "
-              "on an NPTL system.\n"
-              "This can result in crashes on some distributions due "
-              "to LT/NPTL conflicts.\n"
-              "You should either build a dynamically-linked binary, or force "
-              "LinuxThreads\n"
-              "to be used with the LD_ASSUME_KERNEL environment variable. "
-              "Please consult\n"
-              "the documentation for your distribution on how to do that.\n"));
-
-#ifdef HAVE_WRITE_CORE
-  if (test_flags.test(TEST_CORE_ON_SIGNAL))
-  {
-    fprintf(stderr, _("Writing a core file\n"));
-    fflush(stderr);
-    write_core(sig);
-  }
-#endif
-
-  exit(1);
-}
+
 
 #ifndef SA_RESETHAND
 #define SA_RESETHAND 0
@@ -892,65 +716,12 @@
 #endif
 
 
-/**
-  All global error messages are sent here where the first one is stored
-  for the client.
-*/
-static void my_message_sql(uint32_t error, const char *str, myf MyFlags)
+
+
+const char *load_default_groups[]= 
 {
-  Session *session;
-  /*
-    Put here following assertion when situation with EE_* error codes
-    will be fixed
-  */
-  if ((session= current_session))
-  {
-    if (MyFlags & ME_FATALERROR)
-      session->is_fatal_error= 1;
-
-    /*
-      TODO: There are two exceptions mechanism (Session and sp_rcontext),
-      this could be improved by having a common stack of handlers.
-    */
-    if (session->handle_error(error, str,
-                          DRIZZLE_ERROR::WARN_LEVEL_ERROR))
-      return;;
-
-    /*
-      session->lex->current_select == 0 if lex structure is not inited
-      (not query command (COM_QUERY))
-    */
-    if (! (session->lex->current_select &&
-        session->lex->current_select->no_error && !session->is_fatal_error))
-    {
-      if (! session->main_da.is_error())            // Return only first message
-      {
-        if (error == 0)
-          error= ER_UNKNOWN_ERROR;
-        if (str == NULL)
-          str= ER(error);
-        session->main_da.set_error_status(error, str);
-      }
-    }
-
-    if (!session->no_warnings_for_error && !session->is_fatal_error)
-    {
-      /*
-        Suppress infinite recursion if there a memory allocation error
-        inside push_warning.
-      */
-      session->no_warnings_for_error= true;
-      push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_ERROR, error, str);
-      session->no_warnings_for_error= false;
-    }
-  }
-  if (!session || MyFlags & ME_NOREFRESH)
-    errmsg_printf(ERRMSG_LVL_ERROR, "%s: %s",internal::my_progname,str);
-}
-
-
-static const char *load_default_groups[]= {
-DRIZZLE_CONFIG_NAME, "server", 0, 0};
+  DRIZZLE_CONFIG_NAME, "server", 0, 0
+};
 
 static int show_starttime(SHOW_VAR *var, char *buff)
 {
@@ -1106,8 +877,8 @@
   {NULL, NULL, SHOW_LONGLONG}
 };
 
-static int init_common_variables(const char *conf_file_name, int argc,
-                                 char **argv, const char **groups)
+int init_common_variables(const char *conf_file_name, int argc,
+                          char **argv, const char **groups)
 {
   time_t curr_time;
   umask(((~internal::my_umask) & 0666));
@@ -1257,7 +1028,7 @@
 }
 
 
-static int init_server_components(plugin::Registry &plugins)
+int init_server_components(plugin::Registry &plugins)
 {
   /*
     We need to call each of these following functions to ensure that
@@ -1867,7 +1638,6 @@
   drizzle_home[0]= pidfile_name[0]= 0;
   opt_tc_log_file= (char *)"tc.log";      // no hostname in tc_log file name !
   opt_secure_file_priv= 0;
-  segfaulted= 0;
   cleanup_done= 0;
   defaults_argc= 0;
   defaults_argv= 0;
@@ -2174,11 +1944,11 @@
       progdir.assign(progdir.substr(0, progdir.rfind(".libs/")));
     }
     string testfile(progdir);
-    testfile.append("drizzled.o");
+    testfile.append("drizzled.lo");
     struct stat testfile_stat;
     if (stat(testfile.c_str(), &testfile_stat))
     {
-      /* drizzled.o doesn't exist - we are not in a source dir.
+      /* drizzled.lo doesn't exist - we are not in a source dir.
        * Go on as usual
        */
       (void) internal::my_load_path(opt_plugin_dir, get_relative_path(PKGPLUGINDIR),
@@ -2247,194 +2017,3 @@
 
 } /* namespace drizzled */
 
-using namespace drizzled;
-
-
-static void init_signals(void)
-{
-  sigset_t set;
-  struct sigaction sa;
-
-  if (!(test_flags.test(TEST_NO_STACKTRACE) || 
-        test_flags.test(TEST_CORE_ON_SIGNAL)))
-  {
-    sa.sa_flags = SA_RESETHAND | SA_NODEFER;
-    sigemptyset(&sa.sa_mask);
-    sigprocmask(SIG_SETMASK,&sa.sa_mask,NULL);
-
-    init_stacktrace();
-    sa.sa_handler=handle_segfault;
-    sigaction(SIGSEGV, &sa, NULL);
-    sigaction(SIGABRT, &sa, NULL);
-#ifdef SIGBUS
-    sigaction(SIGBUS, &sa, NULL);
-#endif
-    sigaction(SIGILL, &sa, NULL);
-    sigaction(SIGFPE, &sa, NULL);
-  }
-
-  if (test_flags.test(TEST_CORE_ON_SIGNAL))
-  {
-    /* Change limits so that we will get a core file */
-    struct rlimit rl;
-    rl.rlim_cur = rl.rlim_max = RLIM_INFINITY;
-    if (setrlimit(RLIMIT_CORE, &rl) && global_system_variables.log_warnings)
-        errmsg_printf(ERRMSG_LVL_WARN,
-                      _("setrlimit could not change the size of core files "
-                        "to 'infinity';  We may not be able to generate a "
-                        "core file on signals"));
-  }
-  (void) sigemptyset(&set);
-  my_sigset(SIGPIPE,SIG_IGN);
-  sigaddset(&set,SIGPIPE);
-#ifndef IGNORE_SIGHUP_SIGQUIT
-  sigaddset(&set,SIGQUIT);
-  sigaddset(&set,SIGHUP);
-#endif
-  sigaddset(&set,SIGTERM);
-
-  /* Fix signals if blocked by parents (can happen on Mac OS X) */
-  sigemptyset(&sa.sa_mask);
-  sa.sa_flags = 0;
-  sa.sa_handler = print_signal_warning;
-  sigaction(SIGTERM, &sa, (struct sigaction*) 0);
-  sa.sa_flags = 0;
-  sa.sa_handler = print_signal_warning;
-  sigaction(SIGHUP, &sa, (struct sigaction*) 0);
-#ifdef SIGTSTP
-  sigaddset(&set,SIGTSTP);
-#endif
-  if (test_flags.test(TEST_SIGINT))
-  {
-    my_sigset(thr_kill_signal, end_thread_signal);
-    // May be SIGINT
-    sigdelset(&set, thr_kill_signal);
-  }
-  else
-    sigaddset(&set,SIGINT);
-  sigprocmask(SIG_SETMASK,&set,NULL);
-  pthread_sigmask(SIG_SETMASK,&set,NULL);
-  return;;
-}
-
-int main(int argc, char **argv)
-{
-#if defined(ENABLE_NLS)
-# if defined(HAVE_LOCALE_H)
-  setlocale(LC_ALL, "");
-# endif
-  bindtextdomain("drizzle", LOCALEDIR);
-  textdomain("drizzle");
-#endif
-
-  plugin::Registry &plugins= plugin::Registry::singleton();
-  plugin::Client *client;
-  Session *session;
-
-  MY_INIT(argv[0]);		// init my_sys library & pthreads
-  /* nothing should come before this line ^^^ */
-
-  /* Set signal used to kill Drizzle */
-#if defined(SIGUSR2)
-  thr_kill_signal= internal::thd_lib_detected == THD_LIB_LT ? SIGINT : SIGUSR2;
-#else
-  thr_kill_signal= SIGINT;
-#endif
-
-  if (init_common_variables(DRIZZLE_CONFIG_NAME,
-			    argc, argv, load_default_groups))
-    unireg_abort(1);				// Will do exit
-
-  init_signals();
-
-
-  select_thread=pthread_self();
-  select_thread_in_use=1;
-
-  if (chdir(drizzle_real_data_home) && !opt_help)
-  {
-    errmsg_printf(ERRMSG_LVL_ERROR, _("Data directory %s does not exist\n"), drizzle_real_data_home);
-    unireg_abort(1);
-  }
-  drizzle_data_home= drizzle_data_home_buff;
-  drizzle_data_home[0]=FN_CURLIB;		// all paths are relative from here
-  drizzle_data_home[1]=0;
-  drizzle_data_home_len= 2;
-
-  if ((user_info= check_user(drizzled_user)))
-  {
-    set_user(drizzled_user, user_info);
-  }
-
-  if (server_id == 0)
-  {
-    server_id= 1;
-  }
-
-  if (init_server_components(plugins))
-    unireg_abort(1);
-
-  if (plugin::Listen::setup())
-    unireg_abort(1);
-
-  /*
-    init signals & alarm
-    After this we can't quit by a simple unireg_abort
-  */
-  error_handler_hook= my_message_sql;
-
-  if (drizzle_rm_tmp_tables() ||
-      my_tz_init((Session *)0, default_tz_name))
-  {
-    abort_loop= true;
-    select_thread_in_use=0;
-    (void) pthread_kill(signal_thread, SIGTERM);
-
-    (void) unlink(pidfile_name);	// Not needed anymore
-
-    exit(1);
-  }
-
-  init_status_vars();
-
-  errmsg_printf(ERRMSG_LVL_INFO, _(ER(ER_STARTUP)), internal::my_progname,
-                PANDORA_RELEASE_VERSION, COMPILATION_COMMENT);
-
-
-  /* Listen for new connections and start new session for each connection
-     accepted. The listen.getClient() method will return NULL when the server
-     should be shutdown. */
-  while ((client= plugin::Listen::getClient()) != NULL)
-  {
-    if (!(session= new Session(client)))
-    {
-      delete client;
-      continue;
-    }
-
-    /* If we error on creation we drop the connection and delete the session. */
-    if (session->schedule())
-      Session::unlink(session);
-  }
-
-  /* (void) pthread_attr_destroy(&connection_attrib); */
-
-
-  (void) pthread_mutex_lock(&LOCK_thread_count);
-  select_thread_in_use=0;			// For close_connections
-  (void) pthread_mutex_unlock(&LOCK_thread_count);
-  (void) pthread_cond_broadcast(&COND_thread_count);
-
-  /* Wait until cleanup is done */
-  (void) pthread_mutex_lock(&LOCK_thread_count);
-  while (!ready_to_exit)
-    pthread_cond_wait(&COND_server_end,&LOCK_thread_count);
-  (void) pthread_mutex_unlock(&LOCK_thread_count);
-
-  clean_up(1);
-  plugin::Registry::shutdown();
-  clean_up_mutexes();
-  internal::my_end();
-  return 0;
-}
-

=== added file 'drizzled/drizzled.h'
--- drizzled/drizzled.h	1970-01-01 00:00:00 +0000
+++ drizzled/drizzled.h	2010-02-16 07:05:28 +0000
@@ -0,0 +1,69 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Monty Taylor
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_DRIZZLED_H
+#define DRIZZLED_DRIZZLED_H
+
+#include <bitset>
+
+#include "drizzled/atomics.h"
+
+extern "C" void drizzled_print_signal_warning(int sig);
+extern "C" void drizzled_handle_segfault(int sig);
+extern "C" void drizzled_end_thread_signal(int sig);
+
+struct passwd;
+
+namespace drizzled
+{
+
+namespace plugin
+{
+class Registry;
+}
+
+extern std::bitset<12> test_flags;
+extern uint32_t max_used_connections;
+extern atomic<uint32_t> connection_count;
+extern bool calling_initgroups;
+extern const char *load_default_groups[];
+extern bool volatile select_thread_in_use;
+extern bool volatile abort_loop;
+extern bool volatile ready_to_exit;
+extern bool opt_help;
+extern bool opt_help_extended;
+extern passwd *user_info;
+extern char *drizzled_user;
+
+extern const char * const DRIZZLE_CONFIG_NAME;
+
+int init_server_components(plugin::Registry &plugins);
+int init_common_variables(const char *conf_file_name, int argc,
+                          char **argv, const char **groups);
+
+passwd *check_user(const char *user);
+void set_user(const char *user, passwd *user_info_arg);
+void clean_up(bool print_message);
+void clean_up_mutexes(void);
+bool drizzle_rm_tmp_tables();
+
+} /* namespace drizzled */
+
+#endif /* DRIZZLED_DRIZZLED_H */

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-02-13 23:50:31 +0000
+++ drizzled/include.am	2010-02-16 07:05:28 +0000
@@ -18,8 +18,6 @@
 #  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 
 
-sbin_PROGRAMS= drizzled/drizzled
-
 DTRACEFILES= \
 	     drizzled/cursor.o \
 	     drizzled/drizzled.o \
@@ -61,6 +59,7 @@
 			      drizzled/definitions.h \
 			      drizzled/diagnostics_area.h \
 			      drizzled/discrete_interval.h \
+			      drizzled/drizzled.h \
 			      drizzled/dtcollation.h \
 			      drizzled/dynamic_array.h \
 			      drizzled/enum.h \
@@ -427,334 +426,336 @@
 			      drizzled/visibility.h \
 			      drizzled/xid.h
 
-DRIZZLED_LDADD= \
-		drizzled/internal/libinternal.la \
-		$(LIBZ) \
-		$(LIBINTL) \
-		${LIBC_P}
-
+lib_LTLIBRARIES+= drizzled/libdrizzled.la
+drizzled_libdrizzled_la_LIBADD= \
+				drizzled/algorithm/libhash.la \
+				drizzled/util/libutil.la \
+                                drizzled/internal/libinternal.la \
+                                drizzled/message/libdrizzledmessage.la \
+                                $(LIBZ) \
+                                $(LIBINTL) \
+                                ${LIBC_P} \
+			        $(pandora_plugin_libs) \
+			        $(LDADD) $(LIBUUID) \
+			        $(LIBDL_LIBS) $(LIBPROTOBUF) $(LIBPCRE) $(LIBTBB) \
+			        $(GCOV_LIBS) 
+
+drizzled_libdrizzled_la_DEPENDENCIES= ${noinst_LTLIBRARIES} $(pandora_plugin_libs)
+
+drizzled_libdrizzled_la_SOURCES= \
+				 drizzled/alter_info.cc \
+				 drizzled/cached_item.cc \
+				 drizzled/calendar.cc \
+				 drizzled/check_stack_overrun.cc \
+				 drizzled/comp_creator.cc \
+				 drizzled/create_field.cc \
+				 drizzled/current_session.cc \
+				 drizzled/cursor.cc \
+				 drizzled/decimal.cc \
+				 drizzled/diagnostics_area.cc \
+				 drizzled/drizzled.cc \
+				 drizzled/dtcollation.cc \
+				 drizzled/errmsg_print.cc \
+				 drizzled/field.cc \
+				 drizzled/field/blob.cc \
+				 drizzled/field/date.cc \
+				 drizzled/field/datetime.cc \
+				 drizzled/field/decimal.cc \
+				 drizzled/field/double.cc \
+				 drizzled/field/enum.cc \
+				 drizzled/field/int64_t.cc \
+				 drizzled/field/long.cc \
+				 drizzled/field/null.cc \
+				 drizzled/field/num.cc \
+				 drizzled/field/real.cc \
+				 drizzled/field/str.cc \
+				 drizzled/field/timestamp.cc \
+				 drizzled/field/varstring.cc \
+				 drizzled/field_conv.cc \
+				 drizzled/field_iterator.cc \
+				 drizzled/file_exchange.cc \
+				 drizzled/filesort.cc \
+				 drizzled/foreign_key.cc \
+				 drizzled/function/additive_op.cc \
+				 drizzled/function/coercibility.cc \
+				 drizzled/function/field.cc \
+				 drizzled/function/find_in_set.cc \
+				 drizzled/function/found_rows.cc \
+				 drizzled/function/func.cc \
+				 drizzled/function/get_system_var.cc \
+				 drizzled/function/get_user_var.cc \
+				 drizzled/function/last_insert.cc \
+				 drizzled/function/locate.cc \
+				 drizzled/function/math/abs.cc \
+				 drizzled/function/math/acos.cc \
+				 drizzled/function/math/asin.cc \
+				 drizzled/function/math/atan.cc \
+				 drizzled/function/math/ceiling.cc \
+				 drizzled/function/math/cos.cc \
+				 drizzled/function/math/decimal_typecast.cc \
+				 drizzled/function/math/divide.cc \
+				 drizzled/function/math/exp.cc \
+				 drizzled/function/math/floor.cc \
+				 drizzled/function/math/int.cc \
+				 drizzled/function/math/int_divide.cc \
+				 drizzled/function/math/int_val.cc \
+				 drizzled/function/math/integer.cc \
+				 drizzled/function/math/ln.cc \
+				 drizzled/function/math/log.cc \
+				 drizzled/function/math/minus.cc \
+				 drizzled/function/math/mod.cc \
+				 drizzled/function/math/multiply.cc \
+				 drizzled/function/math/neg.cc \
+				 drizzled/function/math/ord.cc \
+				 drizzled/function/math/plus.cc \
+				 drizzled/function/math/pow.cc \
+				 drizzled/function/math/rand.cc \
+				 drizzled/function/math/real.cc \
+				 drizzled/function/math/round.cc \
+				 drizzled/function/math/sin.cc \
+				 drizzled/function/math/sqrt.cc \
+				 drizzled/function/math/tan.cc \
+				 drizzled/function/min_max.cc \
+				 drizzled/function/num1.cc \
+				 drizzled/function/num_op.cc \
+				 drizzled/function/numhybrid.cc \
+				 drizzled/function/row_count.cc \
+				 drizzled/function/set_user_var.cc \
+				 drizzled/function/sign.cc \
+				 drizzled/function/str/alloc_buffer.cc \
+				 drizzled/function/str/binary.cc \
+				 drizzled/function/str/char.cc \
+				 drizzled/function/str/collation.cc \
+				 drizzled/function/str/concat.cc \
+				 drizzled/function/str/conv.cc \
+				 drizzled/function/str/conv_charset.cc \
+				 drizzled/function/str/database.cc \
+				 drizzled/function/str/elt.cc \
+				 drizzled/function/str/export_set.cc \
+				 drizzled/function/str/format.cc \
+				 drizzled/function/str/hex.cc \
+				 drizzled/function/str/insert.cc \
+				 drizzled/function/str/left.cc \
+				 drizzled/function/str/load_file.cc \
+				 drizzled/function/str/make_set.cc \
+				 drizzled/function/str/pad.cc \
+				 drizzled/function/str/quote.cc \
+				 drizzled/function/str/repeat.cc \
+				 drizzled/function/str/replace.cc \
+				 drizzled/function/str/reverse.cc \
+				 drizzled/function/str/right.cc \
+				 drizzled/function/str/set_collation.cc \
+				 drizzled/function/str/str_conv.cc \
+				 drizzled/function/str/strfunc.cc \
+				 drizzled/function/str/substr.cc \
+				 drizzled/function/str/trim.cc \
+				 drizzled/function/str/user.cc \
+				 drizzled/function/str/uuid.cc \
+				 drizzled/function/time/curdate.cc \
+				 drizzled/function/time/date.cc \
+				 drizzled/function/time/date_add_interval.cc \
+				 drizzled/function/time/date_format.cc \
+				 drizzled/function/time/dayname.cc \
+				 drizzled/function/time/dayofmonth.cc \
+				 drizzled/function/time/dayofyear.cc \
+				 drizzled/function/time/extract.cc \
+				 drizzled/function/time/from_days.cc \
+				 drizzled/function/time/from_unixtime.cc \
+				 drizzled/function/time/hour.cc \
+				 drizzled/function/time/last_day.cc \
+				 drizzled/function/time/makedate.cc \
+				 drizzled/function/time/microsecond.cc \
+				 drizzled/function/time/minute.cc \
+				 drizzled/function/time/month.cc \
+				 drizzled/function/time/now.cc \
+				 drizzled/function/time/period_add.cc \
+				 drizzled/function/time/period_diff.cc \
+				 drizzled/function/time/quarter.cc \
+				 drizzled/function/time/second.cc \
+				 drizzled/function/time/sysdate_local.cc \
+				 drizzled/function/time/timestamp_diff.cc \
+				 drizzled/function/time/to_days.cc \
+				 drizzled/function/time/typecast.cc \
+				 drizzled/function/time/unix_timestamp.cc \
+				 drizzled/function/time/weekday.cc \
+				 drizzled/function/time/year.cc \
+				 drizzled/function/units.cc \
+				 drizzled/function/user_var_as_out_param.cc \
+				 drizzled/ha_commands.cc \
+				 drizzled/ha_trx_info.cc \
+				 drizzled/hybrid_type_traits.cc \
+				 drizzled/hybrid_type_traits_decimal.cc \
+				 drizzled/hybrid_type_traits_integer.cc \
+				 drizzled/index_hint.cc \
+				 drizzled/item.cc \
+				 drizzled/item/bin_string.cc \
+				 drizzled/item/cache.cc \
+				 drizzled/item/cache_decimal.cc \
+				 drizzled/item/cache_int.cc \
+				 drizzled/item/cache_real.cc \
+				 drizzled/item/cache_row.cc \
+				 drizzled/item/cache_str.cc \
+				 drizzled/item/cmpfunc.cc \
+				 drizzled/item/copy_string.cc \
+				 drizzled/item/create.cc \
+				 drizzled/item/decimal.cc \
+				 drizzled/item/default_value.cc \
+				 drizzled/item/direct_ref.cc \
+				 drizzled/item/empty_string.cc \
+				 drizzled/item/field.cc \
+				 drizzled/item/float.cc \
+				 drizzled/item/hex_string.cc \
+				 drizzled/item/ident.cc \
+				 drizzled/item/insert_value.cc \
+				 drizzled/item/int.cc \
+				 drizzled/item/int_with_ref.cc \
+				 drizzled/item/null.cc \
+				 drizzled/item/num.cc \
+				 drizzled/item/outer_ref.cc \
+				 drizzled/item/ref.cc \
+				 drizzled/item/ref_null_helper.cc \
+				 drizzled/item/row.cc \
+				 drizzled/item/string.cc \
+				 drizzled/item/subselect.cc \
+				 drizzled/item/sum.cc \
+				 drizzled/item/type_holder.cc \
+				 drizzled/item/uint.cc \
+				 drizzled/join.cc \
+				 drizzled/join_cache.cc \
+				 drizzled/join_table.cc \
+				 drizzled/key.cc \
+				 drizzled/key_map.cc \
+				 drizzled/lock.cc \
+				 drizzled/lookup_symbol.cc \
+				 drizzled/my_decimal.cc \
+				 drizzled/my_getsystime.cc \
+				 drizzled/my_hash.cc \
+				 drizzled/my_time.cc \
+				 drizzled/my_tree.cc \
+				 drizzled/name_resolution_context_state.cc \
+				 drizzled/natural_join_column.cc \
+				 drizzled/optimizer/explain_plan.cc \
+				 drizzled/optimizer/key_field.cc \
+				 drizzled/optimizer/quick_group_min_max_select.cc \
+				 drizzled/optimizer/quick_index_merge_select.cc \
+				 drizzled/optimizer/quick_range.cc \
+				 drizzled/optimizer/quick_range_select.cc \
+				 drizzled/optimizer/quick_ror_intersect_select.cc \
+				 drizzled/optimizer/quick_ror_union_select.cc \
+				 drizzled/optimizer/range.cc \
+				 drizzled/optimizer/sel_arg.cc \
+				 drizzled/optimizer/sum.cc \
+				 drizzled/plugin/authentication.cc \
+				 drizzled/plugin/client.cc \
+				 drizzled/plugin/error_message.cc \
+				 drizzled/plugin/function.cc \
+				 drizzled/plugin/info_schema_table.cc \
+				 drizzled/plugin/library.cc \
+				 drizzled/plugin/listen.cc \
+				 drizzled/plugin/listen_tcp.cc \
+				 drizzled/plugin/loader.cc \
+				 drizzled/plugin/logging.cc \
+				 drizzled/plugin/plugin.cc \
+				 drizzled/plugin/query_cache.cc \
+				 drizzled/plugin/registry.cc \
+				 drizzled/plugin/scheduler.cc \
+				 drizzled/plugin/storage_engine.cc \
+				 drizzled/plugin/table_function.cc \
+				 drizzled/plugin/transaction_applier.cc \
+				 drizzled/plugin/transaction_replicator.cc \
+				 drizzled/query_id.cc \
+				 drizzled/records.cc \
+				 drizzled/replication_services.cc \
+				 drizzled/session.cc \
+				 drizzled/session_list.cc \
+				 drizzled/set_var.cc \
+				 drizzled/show.cc \
+				 drizzled/signal_handler.cc \
+				 drizzled/sql_base.cc \
+				 drizzled/sql_bitmap.cc \
+				 drizzled/sql_delete.cc \
+				 drizzled/sql_derived.cc \
+				 drizzled/sql_error.cc \
+				 drizzled/sql_insert.cc \
+				 drizzled/sql_lex.cc \
+				 drizzled/sql_list.cc \
+				 drizzled/sql_load.cc \
+				 drizzled/sql_locale.cc \
+				 drizzled/sql_parse.cc \
+				 drizzled/sql_select.cc \
+				 drizzled/sql_state.cc \
+				 drizzled/sql_string.cc \
+				 drizzled/sql_table.cc \
+				 drizzled/sql_union.cc \
+				 drizzled/sql_update.cc \
+				 drizzled/sql_yacc.yy \
+				 drizzled/stacktrace.cc \
+				 drizzled/statement/alter_schema.cc \
+				 drizzled/statement/alter_table.cc \
+				 drizzled/statement/analyze.cc \
+				 drizzled/statement/change_schema.cc \
+				 drizzled/statement/check.cc \
+				 drizzled/statement/checksum.cc \
+				 drizzled/statement/commit.cc \
+				 drizzled/statement/create_index.cc \
+				 drizzled/statement/create_schema.cc \
+				 drizzled/statement/create_table.cc \
+				 drizzled/statement/delete.cc \
+				 drizzled/statement/drop_index.cc \
+				 drizzled/statement/drop_schema.cc \
+				 drizzled/statement/drop_table.cc \
+				 drizzled/statement/empty_query.cc \
+				 drizzled/statement/flush.cc \
+				 drizzled/statement/insert.cc \
+				 drizzled/statement/insert_select.cc \
+				 drizzled/statement/kill.cc \
+				 drizzled/statement/load.cc \
+				 drizzled/statement/release_savepoint.cc \
+				 drizzled/statement/rename_table.cc \
+				 drizzled/statement/replace.cc \
+				 drizzled/statement/replace_select.cc \
+				 drizzled/statement/rollback.cc \
+				 drizzled/statement/rollback_to_savepoint.cc \
+				 drizzled/statement/savepoint.cc \
+				 drizzled/statement/select.cc \
+				 drizzled/statement/set_option.cc \
+				 drizzled/statement/show_create.cc \
+				 drizzled/statement/show_create_schema.cc \
+				 drizzled/statement/show_errors.cc \
+				 drizzled/statement/show_processlist.cc \
+				 drizzled/statement/show_status.cc \
+				 drizzled/statement/show_warnings.cc \
+				 drizzled/statement/start_transaction.cc \
+				 drizzled/statement/truncate.cc \
+				 drizzled/statement/unlock_tables.cc \
+				 drizzled/statement/update.cc \
+				 drizzled/strfunc.cc \
+				 drizzled/table.cc \
+				 drizzled/table_function_container.cc \
+				 drizzled/table_identifier.cc \
+				 drizzled/table_list.cc \
+				 drizzled/table_share.cc \
+				 drizzled/temporal.cc \
+				 drizzled/temporal_format.cc \
+				 drizzled/temporal_interval.cc \
+				 drizzled/thr_lock.cc \
+				 drizzled/time_functions.cc \
+				 drizzled/transaction_services.cc \
+				 drizzled/tztime.cc \
+				 drizzled/uniques.cc \
+				 drizzled/user_var_entry.cc \
+				 drizzled/version.cc \
+				 drizzled/xid.cc
+
+sbin_PROGRAMS+= drizzled/drizzled
+
+drizzled_drizzled_SOURCES= \
+                           drizzled/main.cc
 drizzled_drizzled_LDADD= \
-			 ${DRIZZLED_LDADD} \
-			 ${noinst_LTLIBRARIES} \
-			 drizzled/algorithm/libhash.la \
-			 drizzled/util/libutil.la \
-			 drizzled/message/libdrizzledmessage.la \
-			 drizzled/libcached_directory.la \
-			 drizzled/liberror.la \
-			 drizzled/libmemory.la \
-			 $(pandora_plugin_libs) \
-			 $(LDADD) $(LIBUUID) gnulib/libgnu.la \
-			 $(LIBDL_LIBS) $(LIBPROTOBUF) $(LIBPCRE) $(LIBTBB) \
-			 $(PANDORA_PLUGIN_DEP_LIBS) $(GCOV_LIBS) 
-
-drizzled_drizzled_DEPENDENCIES= ${noinst_LTLIBRARIES} $(pandora_plugin_libs)
+                         drizzled/libdrizzled.la
 
 drizzled_drizzled_LDFLAGS= -export-dynamic
 
-drizzled_drizzled_SOURCES= \
-			   drizzled/alter_info.cc \
-			   drizzled/cached_item.cc \
-			   drizzled/calendar.cc \
-			   drizzled/check_stack_overrun.cc \
-			   drizzled/comp_creator.cc \
-			   drizzled/create_field.cc \
-			   drizzled/current_session.cc \
-			   drizzled/cursor.cc \
-			   drizzled/decimal.cc \
-			   drizzled/diagnostics_area.cc \
-			   drizzled/drizzled.cc \
-			   drizzled/dtcollation.cc \
-			   drizzled/errmsg_print.cc \
-			   drizzled/field.cc \
-			   drizzled/field/blob.cc \
-			   drizzled/field/date.cc \
-			   drizzled/field/datetime.cc \
-			   drizzled/field/decimal.cc \
-			   drizzled/field/double.cc \
-			   drizzled/field/enum.cc \
-			   drizzled/field/int64_t.cc \
-			   drizzled/field/long.cc \
-			   drizzled/field/null.cc \
-			   drizzled/field/num.cc \
-			   drizzled/field/real.cc \
-			   drizzled/field/str.cc \
-			   drizzled/field/timestamp.cc \
-			   drizzled/field/varstring.cc \
-			   drizzled/field_conv.cc \
-			   drizzled/field_iterator.cc \
-			   drizzled/file_exchange.cc \
-			   drizzled/filesort.cc \
-			   drizzled/foreign_key.cc \
-			   drizzled/function/additive_op.cc \
-			   drizzled/function/coercibility.cc \
-			   drizzled/function/field.cc \
-			   drizzled/function/find_in_set.cc \
-			   drizzled/function/found_rows.cc \
-			   drizzled/function/func.cc \
-			   drizzled/function/get_system_var.cc \
-			   drizzled/function/get_user_var.cc \
-			   drizzled/function/last_insert.cc \
-			   drizzled/function/locate.cc \
-			   drizzled/function/math/abs.cc \
-			   drizzled/function/math/acos.cc \
-			   drizzled/function/math/asin.cc \
-			   drizzled/function/math/atan.cc \
-			   drizzled/function/math/ceiling.cc \
-			   drizzled/function/math/cos.cc \
-			   drizzled/function/math/decimal_typecast.cc \
-			   drizzled/function/math/divide.cc \
-			   drizzled/function/math/exp.cc \
-			   drizzled/function/math/floor.cc \
-			   drizzled/function/math/int.cc \
-			   drizzled/function/math/int_divide.cc \
-			   drizzled/function/math/int_val.cc \
-			   drizzled/function/math/integer.cc \
-			   drizzled/function/math/ln.cc \
-			   drizzled/function/math/log.cc \
-			   drizzled/function/math/minus.cc \
-			   drizzled/function/math/mod.cc \
-			   drizzled/function/math/multiply.cc \
-			   drizzled/function/math/neg.cc \
-			   drizzled/function/math/ord.cc \
-			   drizzled/function/math/plus.cc \
-			   drizzled/function/math/pow.cc \
-			   drizzled/function/math/rand.cc \
-			   drizzled/function/math/real.cc \
-			   drizzled/function/math/round.cc \
-			   drizzled/function/math/sin.cc \
-			   drizzled/function/math/sqrt.cc \
-			   drizzled/function/math/tan.cc \
-			   drizzled/function/min_max.cc \
-			   drizzled/function/num1.cc \
-			   drizzled/function/num_op.cc \
-			   drizzled/function/numhybrid.cc \
-			   drizzled/function/row_count.cc \
-			   drizzled/function/set_user_var.cc \
-			   drizzled/function/sign.cc \
-			   drizzled/function/str/alloc_buffer.cc \
-			   drizzled/function/str/binary.cc \
-			   drizzled/function/str/char.cc \
-			   drizzled/function/str/collation.cc \
-			   drizzled/function/str/concat.cc \
-			   drizzled/function/str/conv.cc \
-			   drizzled/function/str/conv_charset.cc \
-			   drizzled/function/str/database.cc \
-			   drizzled/function/str/elt.cc \
-			   drizzled/function/str/export_set.cc \
-			   drizzled/function/str/format.cc \
-			   drizzled/function/str/hex.cc \
-			   drizzled/function/str/insert.cc \
-			   drizzled/function/str/left.cc \
-			   drizzled/function/str/load_file.cc \
-			   drizzled/function/str/make_set.cc \
-			   drizzled/function/str/pad.cc \
-			   drizzled/function/str/quote.cc \
-			   drizzled/function/str/repeat.cc \
-			   drizzled/function/str/replace.cc \
-			   drizzled/function/str/reverse.cc \
-			   drizzled/function/str/right.cc \
-			   drizzled/function/str/set_collation.cc \
-			   drizzled/function/str/str_conv.cc \
-			   drizzled/function/str/strfunc.cc \
-			   drizzled/function/str/substr.cc \
-			   drizzled/function/str/trim.cc \
-			   drizzled/function/str/user.cc \
-			   drizzled/function/str/uuid.cc \
-			   drizzled/function/time/curdate.cc \
-			   drizzled/function/time/date.cc \
-			   drizzled/function/time/date_add_interval.cc \
-			   drizzled/function/time/date_format.cc \
-			   drizzled/function/time/dayname.cc \
-			   drizzled/function/time/dayofmonth.cc \
-			   drizzled/function/time/dayofyear.cc \
-			   drizzled/function/time/extract.cc \
-			   drizzled/function/time/from_days.cc \
-			   drizzled/function/time/from_unixtime.cc \
-			   drizzled/function/time/hour.cc \
-			   drizzled/function/time/last_day.cc \
-			   drizzled/function/time/makedate.cc \
-			   drizzled/function/time/microsecond.cc \
-			   drizzled/function/time/minute.cc \
-			   drizzled/function/time/month.cc \
-			   drizzled/function/time/now.cc \
-			   drizzled/function/time/period_add.cc \
-			   drizzled/function/time/period_diff.cc \
-			   drizzled/function/time/quarter.cc \
-			   drizzled/function/time/second.cc \
-			   drizzled/function/time/sysdate_local.cc \
-			   drizzled/function/time/timestamp_diff.cc \
-			   drizzled/function/time/to_days.cc \
-			   drizzled/function/time/typecast.cc \
-			   drizzled/function/time/unix_timestamp.cc \
-			   drizzled/function/time/weekday.cc \
-			   drizzled/function/time/year.cc \
-			   drizzled/function/units.cc \
-			   drizzled/function/user_var_as_out_param.cc \
-			   drizzled/ha_commands.cc \
-			   drizzled/ha_trx_info.cc \
-			   drizzled/hybrid_type_traits.cc \
-			   drizzled/hybrid_type_traits_decimal.cc \
-			   drizzled/hybrid_type_traits_integer.cc \
-			   drizzled/index_hint.cc \
-			   drizzled/item.cc \
-			   drizzled/item/bin_string.cc \
-			   drizzled/item/cache.cc \
-			   drizzled/item/cache_decimal.cc \
-			   drizzled/item/cache_int.cc \
-			   drizzled/item/cache_real.cc \
-			   drizzled/item/cache_row.cc \
-			   drizzled/item/cache_str.cc \
-			   drizzled/item/cmpfunc.cc \
-			   drizzled/item/copy_string.cc \
-			   drizzled/item/create.cc \
-			   drizzled/item/decimal.cc \
-			   drizzled/item/default_value.cc \
-			   drizzled/item/direct_ref.cc \
-			   drizzled/item/empty_string.cc \
-			   drizzled/item/field.cc \
-			   drizzled/item/float.cc \
-			   drizzled/item/hex_string.cc \
-			   drizzled/item/ident.cc \
-			   drizzled/item/insert_value.cc \
-			   drizzled/item/int.cc \
-			   drizzled/item/int_with_ref.cc \
-			   drizzled/item/null.cc \
-			   drizzled/item/num.cc \
-			   drizzled/item/outer_ref.cc \
-			   drizzled/item/ref.cc \
-			   drizzled/item/ref_null_helper.cc \
-			   drizzled/item/row.cc \
-			   drizzled/item/string.cc \
-			   drizzled/item/subselect.cc \
-			   drizzled/item/sum.cc \
-			   drizzled/item/type_holder.cc \
-			   drizzled/item/uint.cc \
-			   drizzled/join.cc \
-			   drizzled/join_cache.cc \
-			   drizzled/join_table.cc \
-			   drizzled/key.cc \
-			   drizzled/key_map.cc \
-			   drizzled/lock.cc \
-			   drizzled/lookup_symbol.cc \
-			   drizzled/my_decimal.cc \
-			   drizzled/my_getsystime.cc \
-			   drizzled/my_hash.cc \
-			   drizzled/my_time.cc \
-			   drizzled/my_tree.cc \
-			   drizzled/name_resolution_context_state.cc \
-			   drizzled/natural_join_column.cc \
-			   drizzled/optimizer/explain_plan.cc \
-			   drizzled/optimizer/key_field.cc \
-			   drizzled/optimizer/quick_group_min_max_select.cc \
-			   drizzled/optimizer/quick_index_merge_select.cc \
-			   drizzled/optimizer/quick_range.cc \
-			   drizzled/optimizer/quick_range_select.cc \
-			   drizzled/optimizer/quick_ror_intersect_select.cc \
-			   drizzled/optimizer/quick_ror_union_select.cc \
-			   drizzled/optimizer/range.cc \
-			   drizzled/optimizer/sel_arg.cc \
-			   drizzled/optimizer/sum.cc \
-			   drizzled/plugin/authentication.cc \
-			   drizzled/plugin/client.cc \
-			   drizzled/plugin/error_message.cc \
-			   drizzled/plugin/function.cc \
-			   drizzled/plugin/info_schema_table.cc \
-			   drizzled/plugin/library.cc \
-			   drizzled/plugin/listen.cc \
-			   drizzled/plugin/listen_tcp.cc \
-			   drizzled/plugin/loader.cc \
-			   drizzled/plugin/logging.cc \
-			   drizzled/plugin/plugin.cc \
-			   drizzled/plugin/query_cache.cc \
-			   drizzled/plugin/registry.cc \
-			   drizzled/plugin/scheduler.cc \
-			   drizzled/plugin/storage_engine.cc \
-			   drizzled/plugin/table_function.cc \
-			   drizzled/plugin/transaction_applier.cc \
-			   drizzled/plugin/transaction_replicator.cc \
-			   drizzled/query_id.cc \
-			   drizzled/records.cc \
-			   drizzled/replication_services.cc \
-			   drizzled/session.cc \
-			   drizzled/session_list.cc \
-			   drizzled/set_var.cc \
-			   drizzled/show.cc \
-			   drizzled/sql_base.cc \
-			   drizzled/sql_bitmap.cc \
-			   drizzled/sql_delete.cc \
-			   drizzled/sql_derived.cc \
-			   drizzled/sql_error.cc \
-			   drizzled/sql_insert.cc \
-			   drizzled/sql_lex.cc \
-			   drizzled/sql_list.cc \
-			   drizzled/sql_load.cc \
-			   drizzled/sql_locale.cc \
-			   drizzled/sql_parse.cc \
-			   drizzled/sql_select.cc \
-			   drizzled/sql_state.cc \
-			   drizzled/sql_string.cc \
-			   drizzled/sql_table.cc \
-			   drizzled/sql_union.cc \
-			   drizzled/sql_update.cc \
-			   drizzled/sql_yacc.yy \
-			   drizzled/stacktrace.cc \
-			   drizzled/statement/alter_schema.cc \
-			   drizzled/statement/alter_table.cc \
-			   drizzled/statement/analyze.cc \
-			   drizzled/statement/change_schema.cc \
-			   drizzled/statement/check.cc \
-			   drizzled/statement/checksum.cc \
-			   drizzled/statement/commit.cc \
-			   drizzled/statement/create_index.cc \
-			   drizzled/statement/create_schema.cc \
-			   drizzled/statement/create_table.cc \
-			   drizzled/statement/delete.cc \
-			   drizzled/statement/drop_index.cc \
-			   drizzled/statement/drop_schema.cc \
-			   drizzled/statement/drop_table.cc \
-			   drizzled/statement/empty_query.cc \
-			   drizzled/statement/flush.cc \
-			   drizzled/statement/insert.cc \
-			   drizzled/statement/insert_select.cc \
-			   drizzled/statement/kill.cc \
-			   drizzled/statement/load.cc \
-			   drizzled/statement/release_savepoint.cc \
-			   drizzled/statement/rename_table.cc \
-			   drizzled/statement/replace.cc \
-			   drizzled/statement/replace_select.cc \
-			   drizzled/statement/rollback.cc \
-			   drizzled/statement/rollback_to_savepoint.cc \
-			   drizzled/statement/savepoint.cc \
-			   drizzled/statement/select.cc \
-			   drizzled/statement/set_option.cc \
-			   drizzled/statement/show_create.cc \
-			   drizzled/statement/show_create_schema.cc \
-			   drizzled/statement/show_errors.cc \
-			   drizzled/statement/show_processlist.cc \
-			   drizzled/statement/show_status.cc \
-			   drizzled/statement/show_warnings.cc \
-			   drizzled/statement/start_transaction.cc \
-			   drizzled/statement/truncate.cc \
-			   drizzled/statement/unlock_tables.cc \
-			   drizzled/statement/update.cc \
-			   drizzled/strfunc.cc \
-			   drizzled/table.cc \
-			   drizzled/table_function_container.cc \
-			   drizzled/table_identifier.cc \
-			   drizzled/table_list.cc \
-			   drizzled/table_share.cc \
-			   drizzled/temporal.cc \
-			   drizzled/temporal_format.cc \
-			   drizzled/temporal_interval.cc \
-			   drizzled/thr_lock.cc \
-			   drizzled/time_functions.cc \
-			   drizzled/transaction_services.cc \
-			   drizzled/tztime.cc \
-			   drizzled/uniques.cc \
-			   drizzled/user_var_entry.cc \
-			   drizzled/version.cc \
-			   drizzled/xid.cc
-
 noinst_LTLIBRARIES+= \
 		     drizzled/libcached_directory.la \
 		     drizzled/libcharset.la \

=== modified file 'drizzled/internal/include.am'
--- drizzled/internal/include.am	2010-02-04 08:14:46 +0000
+++ drizzled/internal/include.am	2010-02-16 07:05:28 +0000
@@ -34,7 +34,8 @@
 		drizzled/liberror.la \
 		drizzled/libgetopt.la \
 		drizzled/libmemory.la \
-		drizzled/libtypelib.la
+		drizzled/libtypelib.la \
+		drizzled/libserialutil.la
 
 drizzled_internal_libinternal_la_SOURCES= \
 		drizzled/internal/bmove_upp.cc \

=== added file 'drizzled/main.cc'
--- drizzled/main.cc	1970-01-01 00:00:00 +0000
+++ drizzled/main.cc	2010-02-16 07:05:28 +0000
@@ -0,0 +1,303 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <pthread.h>
+#include <signal.h>
+#include <sys/resource.h>
+#include <unistd.h>
+
+#if TIME_WITH_SYS_TIME
+# include <sys/time.h>
+# include <time.h>
+#else
+# if HAVE_SYS_TIME_H
+#  include <sys/time.h>
+# else
+#  include <time.h>
+# endif
+#endif
+
+#include "drizzled/plugin.h"
+#include "drizzled/gettext.h"
+#include "drizzled/configmake.h"
+#include "drizzled/session.h"
+#include "drizzled/internal/my_sys.h"
+#include "drizzled/unireg.h"
+#include "drizzled/stacktrace.h"
+#include "drizzled/drizzled.h"
+#include "drizzled/errmsg_print.h"
+#include "drizzled/data_home.h"
+#include "drizzled/plugin/listen.h"
+#include "drizzled/plugin/client.h"
+#include "drizzled/pthread_globals.h"
+#include "drizzled/tztime.h"
+
+using namespace drizzled;
+using namespace std;
+
+static pthread_t select_thread;
+static uint32_t thr_kill_signal;
+
+/**
+  All global error messages are sent here where the first one is stored
+  for the client.
+*/
+static void my_message_sql(uint32_t error, const char *str, myf MyFlags)
+{
+  Session *session;
+  /*
+    Put here following assertion when situation with EE_* error codes
+    will be fixed
+  */
+  if ((session= current_session))
+  {
+    if (MyFlags & ME_FATALERROR)
+      session->is_fatal_error= 1;
+
+    /*
+      TODO: There are two exceptions mechanism (Session and sp_rcontext),
+      this could be improved by having a common stack of handlers.
+    */
+    if (session->handle_error(error, str,
+                          DRIZZLE_ERROR::WARN_LEVEL_ERROR))
+      return;;
+
+    /*
+      session->lex->current_select == 0 if lex structure is not inited
+      (not query command (COM_QUERY))
+    */
+    if (! (session->lex->current_select &&
+        session->lex->current_select->no_error && !session->is_fatal_error))
+    {
+      if (! session->main_da.is_error())            // Return only first message
+      {
+        if (error == 0)
+          error= ER_UNKNOWN_ERROR;
+        if (str == NULL)
+          str= ER(error);
+        session->main_da.set_error_status(error, str);
+      }
+    }
+
+    if (!session->no_warnings_for_error && !session->is_fatal_error)
+    {
+      /*
+        Suppress infinite recursion if there a memory allocation error
+        inside push_warning.
+      */
+      session->no_warnings_for_error= true;
+      push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_ERROR, error, str);
+      session->no_warnings_for_error= false;
+      }
+    }
+    if (!session || MyFlags & ME_NOREFRESH)
+        errmsg_printf(ERRMSG_LVL_ERROR, "%s: %s",internal::my_progname,str);
+}
+
+static void init_signals(void)
+{
+  sigset_t set;
+  struct sigaction sa;
+
+  if (!(test_flags.test(TEST_NO_STACKTRACE) || 
+        test_flags.test(TEST_CORE_ON_SIGNAL)))
+  {
+    sa.sa_flags = SA_RESETHAND | SA_NODEFER;
+    sigemptyset(&sa.sa_mask);
+    sigprocmask(SIG_SETMASK,&sa.sa_mask,NULL);
+
+    init_stacktrace();
+    sa.sa_handler= drizzled_handle_segfault;
+    sigaction(SIGSEGV, &sa, NULL);
+    sigaction(SIGABRT, &sa, NULL);
+#ifdef SIGBUS
+    sigaction(SIGBUS, &sa, NULL);
+#endif
+    sigaction(SIGILL, &sa, NULL);
+    sigaction(SIGFPE, &sa, NULL);
+  }
+
+  if (test_flags.test(TEST_CORE_ON_SIGNAL))
+  {
+    /* Change limits so that we will get a core file */
+    struct rlimit rl;
+    rl.rlim_cur = rl.rlim_max = RLIM_INFINITY;
+    if (setrlimit(RLIMIT_CORE, &rl) && global_system_variables.log_warnings)
+        errmsg_printf(ERRMSG_LVL_WARN,
+                      _("setrlimit could not change the size of core files "
+                        "to 'infinity';  We may not be able to generate a "
+                        "core file on signals"));
+  }
+  (void) sigemptyset(&set);
+  my_sigset(SIGPIPE,SIG_IGN);
+  sigaddset(&set,SIGPIPE);
+#ifndef IGNORE_SIGHUP_SIGQUIT
+  sigaddset(&set,SIGQUIT);
+  sigaddset(&set,SIGHUP);
+#endif
+  sigaddset(&set,SIGTERM);
+
+  /* Fix signals if blocked by parents (can happen on Mac OS X) */
+  sigemptyset(&sa.sa_mask);
+  sa.sa_flags = 0;
+  sa.sa_handler = drizzled_print_signal_warning;
+  sigaction(SIGTERM, &sa, (struct sigaction*) 0);
+  sa.sa_flags = 0;
+  sa.sa_handler = drizzled_print_signal_warning;
+  sigaction(SIGHUP, &sa, (struct sigaction*) 0);
+#ifdef SIGTSTP
+  sigaddset(&set,SIGTSTP);
+#endif
+  if (test_flags.test(TEST_SIGINT))
+  {
+    my_sigset(thr_kill_signal, drizzled_end_thread_signal);
+    // May be SIGINT
+    sigdelset(&set, thr_kill_signal);
+  }
+  else
+    sigaddset(&set,SIGINT);
+  sigprocmask(SIG_SETMASK,&set,NULL);
+  pthread_sigmask(SIG_SETMASK,&set,NULL);
+  return;;
+}
+
+
+int main(int argc, char **argv)
+{
+#if defined(ENABLE_NLS)
+# if defined(HAVE_LOCALE_H)
+  setlocale(LC_ALL, "");
+# endif
+  bindtextdomain("drizzle", LOCALEDIR);
+  textdomain("drizzle");
+#endif
+
+  plugin::Registry &plugins= plugin::Registry::singleton();
+  plugin::Client *client;
+  Session *session;
+
+  MY_INIT(argv[0]);		// init my_sys library & pthreads
+  /* nothing should come before this line ^^^ */
+
+  /* Set signal used to kill Drizzle */
+#if defined(SIGUSR2)
+  thr_kill_signal= internal::thd_lib_detected == THD_LIB_LT ? SIGINT : SIGUSR2;
+#else
+  thr_kill_signal= SIGINT;
+#endif
+
+  if (init_common_variables(DRIZZLE_CONFIG_NAME,
+			    argc, argv, load_default_groups))
+    unireg_abort(1);				// Will do exit
+
+  init_signals();
+
+
+  select_thread=pthread_self();
+  select_thread_in_use=1;
+
+  if (chdir(drizzle_real_data_home) && !opt_help)
+  {
+    errmsg_printf(ERRMSG_LVL_ERROR, _("Data directory %s does not exist\n"), drizzle_real_data_home);
+    unireg_abort(1);
+  }
+  drizzle_data_home= drizzle_data_home_buff;
+  drizzle_data_home[0]=FN_CURLIB;		// all paths are relative from here
+  drizzle_data_home[1]=0;
+  drizzle_data_home_len= 2;
+
+  if ((user_info= check_user(drizzled_user)))
+  {
+    set_user(drizzled_user, user_info);
+  }
+
+  if (server_id == 0)
+  {
+    server_id= 1;
+  }
+
+  if (init_server_components(plugins))
+    unireg_abort(1);
+
+  if (plugin::Listen::setup())
+    unireg_abort(1);
+
+  /*
+    init signals & alarm
+    After this we can't quit by a simple unireg_abort
+  */
+  error_handler_hook= my_message_sql;
+
+  if (drizzle_rm_tmp_tables() ||
+      my_tz_init((Session *)0, default_tz_name))
+  {
+    abort_loop= true;
+    select_thread_in_use=0;
+    (void) pthread_kill(signal_thread, SIGTERM);
+
+    (void) unlink(pidfile_name);	// Not needed anymore
+
+    exit(1);
+  }
+
+  init_status_vars();
+
+  errmsg_printf(ERRMSG_LVL_INFO, _(ER(ER_STARTUP)), internal::my_progname,
+                PANDORA_RELEASE_VERSION, COMPILATION_COMMENT);
+
+
+  /* Listen for new connections and start new session for each connection
+     accepted. The listen.getClient() method will return NULL when the server
+     should be shutdown. */
+  while ((client= plugin::Listen::getClient()) != NULL)
+  {
+    if (!(session= new Session(client)))
+    {
+      delete client;
+      continue;
+    }
+
+    /* If we error on creation we drop the connection and delete the session. */
+    if (session->schedule())
+      Session::unlink(session);
+  }
+
+  /* (void) pthread_attr_destroy(&connection_attrib); */
+
+
+  (void) pthread_mutex_lock(&LOCK_thread_count);
+  select_thread_in_use=0;			// For close_connections
+  (void) pthread_mutex_unlock(&LOCK_thread_count);
+  (void) pthread_cond_broadcast(&COND_thread_count);
+
+  /* Wait until cleanup is done */
+  (void) pthread_mutex_lock(&LOCK_thread_count);
+  while (!ready_to_exit)
+    pthread_cond_wait(&COND_server_end,&LOCK_thread_count);
+  (void) pthread_mutex_unlock(&LOCK_thread_count);
+
+  clean_up(1);
+  plugin::Registry::shutdown();
+  clean_up_mutexes();
+  internal::my_end();
+  return 0;
+}
+

=== modified file 'drizzled/message/include.am'
--- drizzled/message/include.am	2010-02-04 08:14:46 +0000
+++ drizzled/message/include.am	2010-02-16 07:05:28 +0000
@@ -32,7 +32,7 @@
 		drizzled/message/master_list_writer \
 		drizzled/message/schema_reader
 
-noinst_LTLIBRARIES += drizzled/message/libdrizzledmessage.la
+lib_LTLIBRARIES += drizzled/message/libdrizzledmessage.la
 
 drizzled_message_libdrizzledmessage_la_CXXFLAGS = ${MESSAGE_AM_CXXFLAGS} ${NO_WERROR}
 

=== modified file 'drizzled/pthread_globals.h'
--- drizzled/pthread_globals.h	2010-02-04 08:14:46 +0000
+++ drizzled/pthread_globals.h	2010-02-16 07:05:28 +0000
@@ -36,6 +36,7 @@
 extern pthread_cond_t COND_refresh;
 extern pthread_cond_t COND_thread_count;
 extern pthread_cond_t COND_global_read_lock;
+extern pthread_cond_t  COND_server_end;
 extern pthread_attr_t connection_attrib;
 extern pthread_t signal_thread;
 

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2010-02-13 23:50:31 +0000
+++ drizzled/session.cc	2010-02-16 07:05:28 +0000
@@ -44,6 +44,7 @@
 #include "drizzled/db.h"
 #include "drizzled/pthread_globals.h"
 #include "drizzled/transaction_services.h"
+#include "drizzled/drizzled.h"
 
 #include "plugin/myisam/myisam.h"
 #include "drizzled/internal/iocache.h"
@@ -72,8 +73,6 @@
 const char * const Session::DEFAULT_WHERE= "field list";
 extern pthread_key_t THR_Session;
 extern pthread_key_t THR_Mem_root;
-extern uint32_t max_used_connections;
-extern atomic<uint32_t> connection_count;
 
 
 /****************************************************************************

=== added file 'drizzled/signal_handler.cc'
--- drizzled/signal_handler.cc	1970-01-01 00:00:00 +0000
+++ drizzled/signal_handler.cc	2010-02-16 07:05:28 +0000
@@ -0,0 +1,204 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <signal.h>
+
+#include "drizzled/drizzled.h"
+#include "drizzled/session.h"
+#include "drizzled/internal/my_sys.h"
+#include "drizzled/probes.h"
+#include "drizzled/plugin.h"
+#include "drizzled/plugin/scheduler.h"
+#include "plugin/myisam/keycache.h"
+
+using namespace drizzled;
+
+static uint32_t killed_threads;
+static bool segfaulted= false;
+
+/*
+ * We declare these extern "C" because they are passed to system callback functions
+ * and Sun Studio does not like it when those don't have C linkage. We prefix them
+ * because extern "C"-ing something effectively removes the namespace from the
+ * linker symbols, meaning they would be exporting symbols like "print_signal_warning
+ */
+extern "C"
+{
+
+void drizzled_print_signal_warning(int sig)
+{
+  if (global_system_variables.log_warnings)
+    errmsg_printf(ERRMSG_LVL_WARN, _("Got signal %d from thread %"PRIu64),
+                  sig, global_thread_id);
+#ifndef HAVE_BSD_SIGNALS
+  my_sigset(sig,drizzled_print_signal_warning);		/* int. thread system calls */
+#endif
+  if (sig == SIGALRM)
+    alarm(2);					/* reschedule alarm */
+}
+
+/** Called when a thread is aborted. */
+void drizzled_end_thread_signal(int )
+{
+  Session *session=current_session;
+  if (session)
+  {
+    statistic_increment(killed_threads, &LOCK_status);
+    session->scheduler->killSessionNow(session);
+    DRIZZLE_CONNECTION_DONE(session->thread_id);
+  }
+  return;
+}
+
+void drizzled_handle_segfault(int sig)
+{
+  time_t curr_time;
+  struct tm tm;
+
+  /*
+    Strictly speaking, one needs a mutex here
+    but since we have got SIGSEGV already, things are a mess
+    so not having the mutex is not as bad as possibly using a buggy
+    mutex - so we keep things simple
+  */
+  if (segfaulted)
+  {
+    fprintf(stderr, _("Fatal signal %d while backtracing\n"), sig);
+    exit(1);
+  }
+
+  segfaulted= true;
+
+  curr_time= time(NULL);
+  if(curr_time == (time_t)-1)
+  {
+    fprintf(stderr, "Fetal: time() call failed\n");
+    exit(1);
+  }
+
+  localtime_r(&curr_time, &tm);
+  
+  fprintf(stderr,"%02d%02d%02d %2d:%02d:%02d - drizzled got signal %d;\n"
+          "This could be because you hit a bug. It is also possible that "
+          "this binary\n or one of the libraries it was linked against is "
+          "corrupt, improperly built,\n or misconfigured. This error can "
+          "also be caused by malfunctioning hardware.\n",
+          tm.tm_year % 100, tm.tm_mon+1, tm.tm_mday,
+          tm.tm_hour, tm.tm_min, tm.tm_sec,
+          sig);
+  fprintf(stderr, _("We will try our best to scrape up some info that "
+                    "will hopefully help diagnose\n"
+                    "the problem, but since we have already crashed, "
+                    "something is definitely wrong\nand this may fail.\n\n"));
+  fprintf(stderr, "key_buffer_size=%u\n",
+          (uint32_t) dflt_key_cache->key_cache_mem_size);
+  fprintf(stderr, "read_buffer_size=%ld\n", (long) global_system_variables.read_buff_size);
+  fprintf(stderr, "max_used_connections=%u\n", max_used_connections);
+  fprintf(stderr, "connection_count=%u\n", uint32_t(connection_count));
+  fprintf(stderr, _("It is possible that drizzled could use up to \n"
+                    "key_buffer_size + (read_buffer_size + "
+                    "sort_buffer_size)*thread_count\n"
+                    "bytes of memory\n"
+                    "Hope that's ok; if not, decrease some variables in the "
+                    "equation.\n\n"));
+
+#ifdef HAVE_STACKTRACE
+  Session *session= current_session;
+
+  if (! (test_flags.test(TEST_NO_STACKTRACE)))
+  {
+    fprintf(stderr,"session: 0x%lx\n",(long) session);
+    fprintf(stderr,_("Attempting backtrace. You can use the following "
+                     "information to find out\n"
+                     "where drizzled died. If you see no messages after this, "
+                     "something went\n"
+                     "terribly wrong...\n"));
+    print_stacktrace(session ? (unsigned char*) session->thread_stack : (unsigned char*) 0,
+                     my_thread_stack_size);
+  }
+  if (session)
+  {
+    const char *kreason= "UNKNOWN";
+    switch (session->killed) {
+    case Session::NOT_KILLED:
+      kreason= "NOT_KILLED";
+      break;
+    case Session::KILL_BAD_DATA:
+      kreason= "KILL_BAD_DATA";
+      break;
+    case Session::KILL_CONNECTION:
+      kreason= "KILL_CONNECTION";
+      break;
+    case Session::KILL_QUERY:
+      kreason= "KILL_QUERY";
+      break;
+    case Session::KILLED_NO_VALUE:
+      kreason= "KILLED_NO_VALUE";
+      break;
+    }
+    fprintf(stderr, _("Trying to get some variables.\n"
+                      "Some pointers may be invalid and cause the "
+                      "dump to abort...\n"));
+    safe_print_str("session->query", session->query, 1024);
+    fprintf(stderr, "session->thread_id=%"PRIu32"\n", (uint32_t) session->thread_id);
+    fprintf(stderr, "session->killed=%s\n", kreason);
+  }
+  fflush(stderr);
+#endif /* HAVE_STACKTRACE */
+
+  if (calling_initgroups)
+    fprintf(stderr, _("\nThis crash occurred while the server was calling "
+                      "initgroups(). This is\n"
+                      "often due to the use of a drizzled that is statically "
+                      "linked against glibc\n"
+                      "and configured to use LDAP in /etc/nsswitch.conf. "
+                      "You will need to either\n"
+                      "upgrade to a version of glibc that does not have this "
+                      "problem (2.3.4 or\n"
+                      "later when used with nscd), disable LDAP in your "
+                      "nsswitch.conf, or use a\n"
+                      "drizzled that is not statically linked.\n"));
+
+  if (internal::thd_lib_detected == THD_LIB_LT && !getenv("LD_ASSUME_KERNEL"))
+    fprintf(stderr,
+            _("\nYou are running a statically-linked LinuxThreads binary "
+              "on an NPTL system.\n"
+              "This can result in crashes on some distributions due "
+              "to LT/NPTL conflicts.\n"
+              "You should either build a dynamically-linked binary, or force "
+              "LinuxThreads\n"
+              "to be used with the LD_ASSUME_KERNEL environment variable. "
+              "Please consult\n"
+              "the documentation for your distribution on how to do that.\n"));
+
+#ifdef HAVE_WRITE_CORE
+  if (test_flags.test(TEST_CORE_ON_SIGNAL))
+  {
+    fprintf(stderr, _("Writing a core file\n"));
+    fflush(stderr);
+    write_core(sig);
+  }
+#endif
+
+  exit(1);
+}
+
+} /* extern "C" */

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2010-02-04 08:14:46 +0000
+++ drizzled/sql_base.cc	2010-02-16 07:05:28 +0000
@@ -51,6 +51,7 @@
 #include "drizzled/global_charset_info.h"
 #include "drizzled/pthread_globals.h"
 #include "drizzled/internal/iocache.h"
+#include "drizzled/drizzled.h"
 
 using namespace std;
 
@@ -59,8 +60,6 @@
 
 extern bool volatile shutdown_in_progress;
 
-bool drizzle_rm_tmp_tables();
-
 /**
   @defgroup Data_Dictionary Data Dictionary
   @{

=== modified file 'drizzled/stacktrace.cc'
--- drizzled/stacktrace.cc	2010-02-04 08:14:46 +0000
+++ drizzled/stacktrace.cc	2010-02-16 07:05:28 +0000
@@ -36,6 +36,10 @@
 #include <cstdio>
 #include <algorithm>
 
+#if defined(BACKTRACE_DEMANGLE)
+# include <cxxabi.h>
+#endif
+
 #include "drizzled/definitions.h"
 
 using namespace std;
@@ -74,8 +78,13 @@
 #define SIGRETURN_FRAME_OFFSET 23
 #endif
 
-
-#if BACKTRACE_DEMANGLE
+#if defined(BACKTRACE_DEMANGLE)
+
+static inline char *my_demangle(const char *mangled_name, int *status)
+{
+  return abi::__cxa_demangle(mangled_name, NULL, NULL, status);
+}
+
 static void my_demangle_symbols(char **addrs, int n)
 {
   int status, i;

=== modified file 'drizzled/stacktrace.h'
--- drizzled/stacktrace.h	2010-02-04 08:14:46 +0000
+++ drizzled/stacktrace.h	2010-02-16 07:05:28 +0000
@@ -35,10 +35,6 @@
 #define BACKTRACE_DEMANGLE 1
 #endif
 
-#if defined(BACKTRACE_DEMANGLE)
-extern "C" char *my_demangle(const char *mangled_name, int *status);
-#endif
-
 #ifdef TARGET_OS_LINUX
 #if defined(HAVE_STACKTRACE) || (defined (__x86_64__) || defined (__i386__) )
 #undef HAVE_STACKTRACE

=== modified file 'extra/include.am'
--- extra/include.am	2010-01-11 23:50:15 +0000
+++ extra/include.am	2010-02-16 07:05:28 +0000
@@ -4,7 +4,4 @@
 
 
 extra_my_print_defaults_SOURCES= extra/my_print_defaults.cc
-extra_my_print_defaults_LDADD= \
-		drizzled/internal/libinternal.la \
-		gnulib/libgnu.la \
-		$(LIBINTL)
+extra_my_print_defaults_LDADD= $(CLIENT_LDADD)

=== modified file 'plugin/myisam/plugin.ini'
--- plugin/myisam/plugin.ini	2010-02-04 08:14:46 +0000
+++ plugin/myisam/plugin.ini	2010-02-16 07:05:28 +0000
@@ -18,6 +18,6 @@
 description=Legacy non-transactional MySQL tables
 load_by_default=yes
 sources=ha_myisam.cc
-libs=plugin/myisam/libmyisam.la drizzled/internal/libinternal.la
+libs=plugin/myisam/libmyisam.la
 ldflags=$(LIBZ) $(LIBINTL)
 static=yes

